<?php
////////////////////////////////////////////////////////////////////////
// Breeze Website Builder
// Copyright Silver Dolphin Solutions, LLC, Edward Lemmers, P.E.
// For licensing, see license.txt.
// Revised: 11/12/2008	ELL
// Fixed bug with custom tags using "#" instead of ".".
// Revised: 7/30/2009	ELL
// Added section for defining class/subclass relationships.
// Revised: 8/1/2009	ELL
// Added ability to operate using different class tables and different CSS tables.  This was done to give the ability
// to style calendar grids and event grids without adding 14 more classes to the site style list.
// Renamed from tags.php to classes.php.
// Added feed thru to show/hide custom styles.
// Revised: 8/25/2009	ELL
// Removed feed thru to show/hide custom styles as no longer need with new design of having completely separate area for doing custom CSS.
// Revised: 2/7/2012	ELL
// Added table prefix handling.
// Revised: 5/29/2012	ELL
// Added ability to revise class descriptions.
// Revised: 2/13/2013	ELL
// Added class/ID dropdown for automatically prefixing class string.
// Revised: 2/18/2013	ELL
// Added checkbox for creating link set.
// Revised: 7/1/2013	ELL
// Implemented popup message class.
// Revised: 12/27/2014	ELL
// Added 'hover' subclass.
// Revised: 2/13/2015	ELL
// Added class selector operators.
// Added comprehensive range of selectors.
// Added alpha sorting of classes.
// 
	include ("check_session.php");
		
	$style_sheet = $_REQUEST['style_sheet'];
	$class_table = $style_sheet . "_classes";
	$last_class_edited = $_SESSION['last_class_edited'];
	if (isset($_GET['class_sort_method']))	{
		$class_sort_method = $_GET['class_sort_method'];
		$_SESSION['class_sort_method'] = $class_sort_method;
	}
	elseif (isset($_SESSION['class_sort_method']))
		$class_sort_method = $_GET['class_sort_method'];
	else
		$class_sort_method = 0;
		
	if ($class_sort_method == 1)	{
		$sort = "`class`";
		$sort2 = "`class`";
	}
	else	{
		$sort = "`sort_order`";
		$sort2 = "`subclass_sort_order`, `sort_order`";
	}
			
		$query = "SELECT * FROM `" . BWB_TABLE_PREFIX . $class_table . "` WHERE `custom` = 1 ORDER BY $sort";
		if ($result = $bwb_dbh->query($query))
		{
			$num_results = $result->rowCount();
			for ($i = 0; $i < $num_results; $i++)
			{
				$row = $result->fetch(PDO::FETCH_ASSOC);
				$class[$i] = $row["class"];
				$description[$i] = $row["description"];
				$sort_order[$i] = $row["sort_order"];
			}
		}
		
		$query = "SELECT * FROM `" . BWB_TABLE_PREFIX . $class_table . "` ORDER BY $sort";
		if ($result = $bwb_dbh->query($query))
		{
			$num_results2 = $result->rowCount();
			for ($i = 0; $i < $num_results2; $i++)
			{
				$row = $result->fetch(PDO::FETCH_ASSOC);
				$class2[$i] = $row["class"];
				$description2[$i] = $row["description"];
				$sort_order2[$i] = $row["sort_order"];
			}
		}
		
		$query = "SELECT * FROM `" . BWB_TABLE_PREFIX . $class_table . "` ORDER BY $sort2";
		if ($result = $bwb_dbh->query($query))
		{
			$num_results2 = $result->rowCount();
			for ($i = 0; $i < $num_results2; $i++)
			{
				$row = $result->fetch(PDO::FETCH_ASSOC);
				$class3[$i] = $row["class"];
				$description3[$i] = $row["description"];
				$sort_order3[$i] = $row["sort_order"];
			}
		}
?>
<html>
<head>
<title>Class Editor | Breeze Website Builder</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link rel="stylesheet" href="theme/<?php echo $theme; ?>/manager.css" type="text/css">
<link rel="shortcut icon" href="images/favicon.ico" type="image/x-icon">

<style type="text/css">
#help_button	{	
	position:relative;
	display:block;
	top:-15px;
	left:215px;
	height:31px;
	width:31px;
	z-index:100;
}
</style>

<script type="text/javascript" src="js/json2.js"></script>
<script type="text/javascript" src="js/ajax.js"></script>
<script type="text/javascript" src="js/mouse_position.js"></script>
<script type="text/javascript" src="js/popup_msg.js"></script>
<script type="text/javascript" src="js/classes.js"></script>

<script language="javascript" type="text/javascript">
<?php
	echo "var EDITOR_STARTING_UPDATE_MSG = \"" . EDITOR_STARTING_UPDATE_MSG . "\";\n";
	echo "var CLASSES_STARTING_POPULATE_MSG = \"" . CLASSES_STARTING_POPULATE_MSG . "\";\n";
	echo "var CLASSES_DELETE_CLASS_CONFIRM_1_MSG = \"" . CLASSES_DELETE_CLASS_CONFIRM_1_MSG . "\";\n";
	echo "var CLASSES_DELETE_CLASS_CONFIRM_2_MSG = \"" . CLASSES_DELETE_CLASS_CONFIRM_2_MSG . "\";\n";
	echo "var CLASSES_LOCATING_DESCRIPTION_MSG = \"" . CLASSES_LOCATING_DESCRIPTION_MSG . "\";\n";
	echo "var CLASSES_DESCRIPTION_NOT_FOUND_MSG = \"" . CLASSES_DESCRIPTION_NOT_FOUND_MSG . "\";\n";
	echo "var CLASSES_DESCRIPTION_FOUND_MSG = \"" . CLASSES_DESCRIPTION_FOUND_MSG . "\";\n";
	echo "var CLASSES_COULD_NOT_UPDATE_DESCRIPTION_MSG = \"" . CLASSES_COULD_NOT_UPDATE_DESCRIPTION_MSG . "\";\n";
	echo "var CLASSES_DESCRIPTION_UPDATED_MSG = \"" . CLASSES_DESCRIPTION_UPDATED_MSG . "\";\n";
	echo "var CLASSES_UPDATING_DESCRIPTION_MSG = \"" . CLASSES_UPDATING_DESCRIPTION_MSG . "\";\n";
	echo "var QUERY_READY_TO_SEND = \"" . QUERY_READY_TO_SEND . "\";\n";
	echo "var QUERY_SENT = \"" . QUERY_SENT . "\";\n";
	echo "var QUERY_COMPLETE = \"" . QUERY_COMPLETE . "\";\n";
	echo "var QUERY_COMPLETE_NO_RECORD_FOUND = \"" . QUERY_COMPLETE_NO_RECORD_FOUND . "\";\n";
	echo "var YES_WORD = \"" . YES_WORD . "\";\n";
	echo "var NO_WORD = \"" . NO_WORD . "\";\n";
	
?>

function DeleteClass()
{
	var class_delete = document.getElementById("class_delete").value;
	class_delete = EscapeClass(class_delete);
	HidePopupMsg();
	var url = "delete_class.php?class=" + class_delete + "&style_sheet=<?php echo $style_sheet; ?>";
	window.location = url;
}

//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
var style_sheet = '<?php echo $style_sheet; ?>';

function PopulateDescription()
{
	var params = "";
	
	popup_msg.top_offset = 0;
	popup_msg.left_offset = 300;
	popup_msg.popup_msg_type = 1;
	popup_msg.status_msg = CLASSES_STARTING_POPULATE_MSG;
	popup_msg.popup_timeout = 3000;

	var xmlhttp;
	xmlhttp = getXmlHttpRequestObject();

	if (xmlhttp.readyState == 4 || xmlhttp.readyState == 0)
	{
		xmlhttp.open("POST","populate_class_description.php",true);
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		xmlhttp = UpdateMessage(xmlhttp, "Populate");
		
		var class_edit = document.getElementById("class_edit").value;
		class_edit = EscapeClass(class_edit);
		params = "class=" + class_edit;
		params = params + "&style_sheet=" + "<?php echo $style_sheet; ?>";
//		alert(params);
		xmlhttp.send(params);
	}
}

//////////////////////////////////////////////////////////////////////////////////////
function UpdateDescription()
{
	var params = "";

	popup_msg.top_offset = 0;
	popup_msg.left_offset = 300;
	popup_msg.popup_msg_type = 1;
	popup_msg.status_msg = EDITOR_STARTING_UPDATE_MSG;
	popup_msg.popup_timeout = 3000;

	var xmlhttp;
	xmlhttp = getXmlHttpRequestObject();

	if (xmlhttp.readyState == 4 || xmlhttp.readyState == 0)
	{
		xmlhttp.open("POST","update_class_description.php",true);
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		xmlhttp = UpdateMessage(xmlhttp, "Update");
		
		var class_edit = document.getElementById("class_edit").value;
		class_edit = EscapeClass(class_edit);
		params = "class=" + class_edit;
		params = params + "&style_sheet=" + "<?php echo $style_sheet; ?>";
		params = params + "&description=" + document.getElementById("description_edit").value;
//		alert(params);
		xmlhttp.send(params);
	}
}

</script>
</head>

<body>
<div align="center">
<table width="80%" border="0"><tr>
<td>
	<div class="button_heading_sub_level_1" id="add_delete_custom_style_heading"><div class="button_heading_text_sub_level_1"><?php echo CLASSES_HEADING; ?></div><div class="help_button" id="help_button" onClick="OpenHelpWindow('classes');">&nbsp;</div></div>
</td>
<td align="right">
  <div class='button_console_go_back' style="width:210px;" onClick="window.location.href='edit_css.php?style_sheet=<?php echo $style_sheet; ?>&goto_class=<?php echo $last_class_edited; ?>'"><span class='button_console_text_w_icon'><?php echo CLASSES_BACK_TO_EDIT_CSS; ?></span></div>
</td></tr></table>

<table width="85%" border="1" cellspacing="0" cellpadding="0"><tr><td>
<form name="formAddTag" id="formAddTag" method="post" action="add_class.php">
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td colspan="6" class="sub_title" style="padding-left:5px;"><?php echo CLASSES_ADD_CLASS; ?></td>
  </tr>
  <tr>
    <td align="right">
    	<select name="class_prefix" id="class_prefix">
            <option value="." selected="selected"><?php echo CLASS_WORD; ?>:</option>
            <option value="#"><?php echo ID_WORD; ?>:</option>
            <option value=""><?php echo _NONE_WORD; ?></option>
        </select>
    </td>
    <td><input type="text" name="class" id="class" /></td>
    <td align="right"><?php echo DESCRIPTION_WORD; ?>:&nbsp;</td>
    <td><input type="text" name="description"></td>
    <td align="right"><?php echo SORT_ORDER; ?>:&nbsp;</td>
    <td><input type="text" name="sort_order" value="100"></td>
  </tr>
  <tr><td colspan="6">&nbsp;<input type="hidden" name="style_sheet" value="<?php echo $style_sheet; ?>" />
  <input type="hidden" name="show_class_editor" value="1" />
  <span class="small_message"><?php echo CLASSES_CLASS_ID_NOTE; ?></span></td></tr>
  <tr>
    <td width="10%">&nbsp;</td>
    <td colspan="4" align="center" >
    <div class='button_console_add' style="width:110px;" onClick="document.getElementById('formAddTag').submit();"><span class='button_console_text_w_icon'><?php echo ADD_WORD; ?></span></div>
    </td>
  	<td width="10%" align="center">&nbsp;
    
  	</td>
  </tr>
  </table>
  </form>
  </td></tr></table>
<br>
  <table width="85%" border="1" cellspacing="0" cellpadding="0"><tr><td>
<form name="formDefineSubclass" id="formDefineSubclass" method="post" action="define_sub_class.php">
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td colspan="6" class="sub_title" style="padding-left:5px;"><?php echo CLASSES_CREATE_SUB_CLASS; ?></td>
  </tr>
  <tr>
    <td align="right"><?php echo CLASS_WORD; ?>:&nbsp;</td>
    <td>
    <select name="class" id="class">
      <?php
	for ($i = 0; $i < $num_results2; $i++)
		echo "<option value='$class2[$i]'>$class2[$i]</option>\n";
?>
    </select>
    </td>
    <td align="center">
    <select name="operator" id="operator" style="visibility:hidden;">
    	<option " "> </option>
        <option ", ">,</option>
        <option " &gt; ">&gt;</option>
        <option " + ">+</option>
        <option " ~ ">~</option>
    </select>
    </td>
    <td align="right" id="subclass_heading_td"><?php echo SUBCLASS_WORD; ?>:&nbsp;</td>
    <td>
    <select name="subclass" id="subclass" onChange="CheckForParam(this.value);">
    	<option value=':link'>:link</option>
        <option value=':hover'>:hover</option>
        <option value=':visited'>:visited</option>
        <option value=':active'>:active</option>
        <option value='::before'>::before</option>
        <option value='::after'>::after</option>
        <option value=':checked'>:checked</option>
        <option value=':disabled'>:disabled</option>
        <option value=':enabled'>:enabled</option>
        <option value=':focus'>:focus</option>
      <?php
	for ($i = 0; $i < $num_results2; $i++)
		echo "<option value='$class3[$i]'>$class3[$i]</option>\n";
?>
		<option value=':target'>:target</option>
        <option value='::selection'>::selection</option>
		<option value=':read-only'>:read-only</option>
        <option value=':read-write'>:read-write</option>
        <option value=':not'>:not</option>
        <option value=':empty'>:empty</option>
        <option value='::first-letter'>::first-letter</option>
        <option value='::first-line'>::first-line</option>
        <option value=':first-child'>:first-child</option>
        <option value=':last-child'>:last-child</option>
        <option value=':nth-child'>:nth-child</option>
        <option value=':nth-last-child'>:nth-last-child</option>
        <option value=':only-child'>:only-child</option>
        <option value=':first-of-type'>:first-of-type</option>
        <option value=':last-of-type'>:last-of-type</option>
        <option value=':nth-of-type'>:nth-of-type</option>
        <option value=':nth-last-of-type'>:nth-last-of-type</option>
        <option value=':only-of-type'>:only-of-type</option>
        <option value=':in-range'>:in-range</option>
        <option value=':out-of-range'>:out-of-range</option>
        <option value=':valid'>:valid</option>
        <option value=':invalid'>:invalid</option>
        <option value=':lang'>:lang</option>
        <option value=':required'>:required</option>
        <option value=':optional'>:optional</option>
        <option value=':root'>:root</option>
    </select>
    <span style="visibility:hidden;" id="selector_param_span">(<input type="text" id="selector_param" name="selector_param" />)</span>
    </td>
    <td>
    	<input type="checkbox" name="create_link_set" id="create_link_set" onClick="EnableDisableSubclass(this.checked);" value="1" />
        <?php echo CLASSES_CREATE_LINK_SET; ?>
    </td>
  </tr>
  <tr>
  	<td colspan="2" align="center">
    	<span class="small_message"><?php echo EDIT_CSS_SORT_ALPHABETICALLY; ?></span> <input type="checkbox" id="sort_alpha_create" name="sort_alpha" <?php if ($class_sort_method == 1) echo "checked='checked'"; ?> onClick="ChangeSort(this.checked);" />
    </td>
    <td align="center"><div class="help_button_sm" id="help_button_operator" onClick="OpenHelpWindow('css_operator');" style="visibility:hidden;">&nbsp;</div></td>
    <td>&nbsp;</td>
    <td align="center">
	    <div class="help_button_sm" id="help_button_selector" onClick="OpenHelpWindow('css_selector');">&nbsp;</div>
    </td>
  	<td align="center">
      <div class="help_button_sm" onClick="OpenHelpWindow('create_link_set');">&nbsp;</div>
      <input type="hidden" name="style_sheet" value="<?php echo $style_sheet; ?>" />
      <input type="hidden" name="show_class_editor" value="1" />
    </td>
  </tr>
  <tr>
    <td colspan="6" align="center">
    <div class='button_console_add' style="width:110px;" onClick="document.getElementById('formDefineSubclass').submit();"><span class='button_console_text_w_icon'><?php echo CREATE_WORD; ?></span></div>
    </td>
  </tr>
  </table>
  </form>
  </td></tr></table>
  <br>
  <table width="85%" border="1" cellspacing="0" cellpadding="0"><tr><td>

  <table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td colspan="4" class="sub_title" style="padding-left:5px;"><?php echo CLASSES_DELETE_CLASS; ?></td>
  </tr>
  <tr>
  	<td>&nbsp;</td>
    <td align="right"><?php echo CLASSES_CLASS_DESCRIPTION; ?>:&nbsp;</td>
    <td>
    <select name="class_delete" id="class_delete">
<?php
	for ($i = 0; $i < $num_results; $i++)
		echo "<option value='$class[$i]'>$class[$i] / $description[$i]</option>\n";
?>
    </select>
    <span class="small_message"><?php echo EDIT_CSS_SORT_ALPHABETICALLY; ?></span> <input type="checkbox" id="sort_alpha_delete" name="sort_alpha" <?php if ($class_sort_method == 1) echo "checked='checked'"; ?> onClick="ChangeSort(this.checked);" />
    </td>
    <td>&nbsp;</td>
  </tr>
  <tr><td colspan="4">&nbsp;</td></tr>
  <tr>
    <td colspan="4" align="center">
    <div class='button_console_delete' style="width:110px;" onClick="DeleteConfirm();"><span class='button_console_text_w_icon'><?php echo EDITOR_DELETE; ?></span></div>
    </td>
  </tr>
</table>

  </td></tr></table>
  <br>
  <table width="85%" border="1" cellspacing="0" cellpadding="0"><tr><td>

  <table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td colspan="4" class="sub_title" style="padding-left:5px;"><?php echo CLASSES_EDIT_CLASS_DESCRIPTION; ?></td>
  </tr>
  <tr>
  	<td align="right"><?php echo CLASS_WORD; ?>:&nbsp;</td>
    <td>
    <select name="class_edit" id="class_edit" onChange="PopulateDescription();">
    <option>-not selected-</option>
<?php
	for ($i = 0; $i < $num_results; $i++)
		echo "<option value='$class[$i]'>$class[$i]</option>\n";
?>
    </select>
    <span class="small_message"><?php echo EDIT_CSS_SORT_ALPHABETICALLY; ?></span> <input type="checkbox" id="sort_alpha_edit" name="sort_alpha" <?php if ($class_sort_method == 1) echo "checked='checked'"; ?> onClick="ChangeSort(this.checked);" />
    </td>
    <td align="right"><?php echo DESCRIPTION_WORD; ?>:&nbsp;</td>
    <td><input type="text" name="description_edit" id="description_edit" /></td>
  </tr>
  <tr>
    <td colspan="4" align="center">
    <div class='button_console_save' style="width:110px;" onClick="UpdateDescription();"><span class='button_console_text_w_icon'><?php echo UPDATE_WORD; ?></span></div>
    </td>
  </tr>
</table>

  </td></tr></table>
  <br>
  <table width="85%" border="1" cellspacing="0" cellpadding="0"><tr><td>
  <form name="formSortTags" id="formSortTags" method="post" action="set_class_sort_order.php">
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td colspan="4" class="sub_title" style="padding-left:5px;"><?php echo CLASSES_SET_CLASS_SORT_ORDER; ?></td>
  </tr>
  <tr bgcolor="#CCCCCC">
  	<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
    <td><b><?php echo CLASSES_CLASS_DESCRIPTION; ?>:</b></td>
    <td><b><?php echo SORT_ORDER; ?>:</b></td>
    <td><b><?php echo CUSTOM_WORD; ?>:</b></td>
  </tr>
<?php
	$query = "SELECT * FROM `" . BWB_TABLE_PREFIX . $class_table . "` ORDER BY `sort_order`";
	if ($result = $bwb_dbh->query($query))
	{
		$num_results = $result->rowCount();
		for ($i = 0; $i < $num_results; $i++)
		{
			$row = $result->fetch(PDO::FETCH_ASSOC);
			$class[$i] = $row["class"];
			$description[$i] = $row["description"];
			$sort_order[$i] = $row["sort_order"];
			$custom[$i] = $row["custom"];
		}
	}
		
	$bgcolor = "#E5E5E5";
	for ($i = 0; $i < $num_results; $i++)
	{
		echo "<tr bgcolor='$bgcolor'>\n<td>&nbsp;</td>\n";
		echo "<td>$class[$i] / $description[$i]<input type='hidden' name='class_$i' value='$class[$i]'></td>\n";
		echo "<td><input type='text' name='sort_order_$i' value='$sort_order[$i]'></td>\n";
		if ($custom[$i] == 1)
			echo "<td>&radic;</td>\n</tr>\n";
		else
			echo "<td>&nbsp;</td>\n</tr>\n";
		if ($bgcolor == "#E5E5E5")
			$bgcolor = "#DDDDDD";
		else
			$bgcolor = "#E5E5E5";
	}
?>
  <tr><td colspan="4">&nbsp;
  <input type="hidden" name="style_sheet" value="<?php echo $style_sheet; ?>" />
  <input type="hidden" name="show_class_editor" value="1" /></td></tr>
  <tr>
    <td colspan="4" align="center">
    <div class='button_console_save' style="width:110px;" onClick="document.getElementById('formSortTags').submit();"><span class='button_console_text_w_icon'><?php echo UPDATE_WORD; ?></span></div>
    </td>
  </tr>
</table>
  </form>
  </td></tr></table>
  <br>
  <table width="80%" border="0" cellspacing="0" cellpadding="0">
  <tr>
  <td align="right">
  <div class='button_console_go_back' style="width:210px;" onClick="window.location.href='edit_css.php?style_sheet=<?php echo $style_sheet; ?>&goto_class=<?php echo $last_class_edited; ?>'"><span class='button_console_text_w_icon'><?php echo CLASSES_BACK_TO_EDIT_CSS; ?></span></div>
  </td>
  </tr>
</table>
</div>

<?php include("lib/popup_msg.html"); ?>

<script language="javascript" type="text/javascript">
	HidePopupMsg();
</script>
</body>
</html>
